Package org.apache.sysds.runtime.instructions.cp

# Class CmCovObject

java.lang.Object
org.apache.sysds.runtime.instructions.cp.Data
org.apache.sysds.runtime.instructions.cp.CmCovObject

All Implemented Interfaces:
  `Serializable`

public class CmCovObject extends Data

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`KahanObject`
`c2`
`KahanObject`
`m2`
`KahanObject`
`m3`
`KahanObject`
`m4`
`double`
`max`
`KahanObject`
`mean`
`KahanObject`
`mean_v`
`double`
`min`
`double`
`w`

## Constructor Summary

Constructors
Constructor
Description
`CmCovObject()`

## Method Summary

Modifier and Type
Method
Description
`int`
`compareTo(CmCovObject that)`
`boolean`
`equals(Object o)`
`String`
`getDebugName()`
`double`
`getRequiredPartialResult(Operator op)`
`double`
`getRequiredResult(CMOperator.AggregateOperationTypes agg)`
Return the result of the aggregated operation given the operation type.
`double`
`getRequiredResult(Operator op)`
Return the result of the aggregated operation given the operator.
`double`
`getWeight()`
`int`
`hashCode()`
`boolean`
`isCMAllZeros()`
`boolean`
`isCOVAllZeros()`
`void`
`reset()`
`void`
`set(CmCovObject that)`
`String`
`toString()`

### Methods inherited from class org.apache.sysds.runtime.instructions.cp.Data

`getDataType, getMetaData, getValueType, removeMetaData, setMetaData, toString, updateDataCharacteristics`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### w

public double w

### mean

public KahanObject mean

### m2

public KahanObject m2

### m3

public KahanObject m3

### m4

public KahanObject m4

### min

public double min

### max

public double max

### mean_v

public KahanObject mean_v

### c2

public KahanObject c2

## Constructor Details

### CmCovObject

public CmCovObject()

## Method Details

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### reset

public void reset()

### compareTo

public int compareTo(CmCovObject that)

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `Object`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`

### set

public void set(CmCovObject that)

### isCMAllZeros

public boolean isCMAllZeros()

### isCOVAllZeros

public boolean isCOVAllZeros()

### getRequiredResult

public double getRequiredResult(Operator op)
Return the result of the aggregated operation given the operator.

Parameters:
  `op` - operator
Returns:
  result of the aggregated operation for the given operator

### getRequiredResult

public double getRequiredResult(CMOperator.AggregateOperationTypes agg)
Return the result of the aggregated operation given the operation type.

Parameters:
  `agg` - aggregate operation type
Returns:
  result of the aggregated operation given the operation type

### getRequiredPartialResult

public double getRequiredPartialResult(Operator op)

### getWeight

public double getWeight()

### getDebugName

public String getDebugName()

Specified by:
  `getDebugName` in class `Data`